# coding: utf-8

"""
    ICA Rest API

    This API can be used to interact with Illumina Connected Analytics.<br> <h2>Authentication</h2> <p> Authentication to the  API can be done in multiple ways:<br> <ul><li>For the entire API, except for the POST /tokens endpoint: API-key + JWT</li> <li>Only for the POST /tokens endpoint: API-key + Basic Authentication</li></ul> </p> <p> <h4>API-key</h4> API keys are managed within the Illumina portal where you can manage your profile after you have logged on. The API-key has to be provided in the X-API-Key header parameter when executing API calls to ICA. In the background, a JWT will be requested at the IDP of Illumina to create a session. A good practice is to not use the API-key for every API call, but to first generate a JWT and to use that for authentication in subsequent calls.<br> </p> <p> <h4>JWT</h4> To avoid using an API-key for each call, we recommend to request a JWT via the POST /tokens endpoint  using this API-key. The JWT will expire after a pre-configured period specified by a tenant administrator through the IAM console in the Illumina portal. The JWT is the preferred way for authentication.<br>A not yet expired, still valid JWT could be refreshed using the POST /tokens:refresh endpoint.<br>Refreshing the JWT is not possible if the JWT was generated by using an API-key.<br> </p> <p> <h4>Basic Authentication</h4> Basic authentication is only supported by the POST /tokens endpoint for generating a JWT. Use \"Basic base64encoded(emailaddress:password)\" in the \"Authorization\" header parameter for this authentication method. In case having access to multiple tenants using the same email-address, also provide the \"tenant\" request parameter to indicate what tenant you would like to request a JWT for. </p> <p> <h2>Compression</h2> If the API client provides request header 'Accept-Encoding' with value 'gzip', then the API applies GZIP compression on the JSON response. This significantly reduces the size and thus the download time of the response, which results in faster end-to-end API calls. In case of compression, the API also provides response header 'Content-Encoding' with value 'gzip', as indication for the client that decompression is required. </p> 

    The version of the OpenAPI document: 3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from libica.openapi.v3.models.input_form_field_choice import InputFormFieldChoice
from libica.openapi.v3.models.input_form_field_data_filter import InputFormFieldDataFilter
from libica.openapi.v3.models.input_form_with_external_data import InputFormWithExternalData
from typing import Optional, Set
from typing_extensions import Self

class InputFormGroupField(BaseModel):
    """
    InputFormGroupField
    """ # noqa: E501
    id: Optional[StrictStr] = None
    type: Optional[StrictStr] = None
    label: Optional[StrictStr] = None
    min_values: Optional[StrictInt] = Field(default=None, alias="minValues")
    max_values: Optional[StrictInt] = Field(default=None, alias="maxValues")
    min_max_values_message: Optional[StrictStr] = Field(default=None, alias="minMaxValuesMessage")
    help_text: Optional[StrictStr] = Field(default=None, alias="helpText")
    place_holder_text: Optional[StrictStr] = Field(default=None, alias="placeHolderText")
    values: Optional[List[StrictStr]] = None
    data_values: Optional[List[InputFormWithExternalData]] = Field(default=None, alias="dataValues")
    min_length: Optional[StrictInt] = Field(default=None, alias="minLength")
    max_length: Optional[StrictInt] = Field(default=None, alias="maxLength")
    min: Optional[Union[StrictFloat, StrictInt]] = None
    max: Optional[Union[StrictFloat, StrictInt]] = None
    choices: Optional[List[InputFormFieldChoice]] = None
    data_filter: Optional[InputFormFieldDataFilter] = Field(default=None, alias="dataFilter")
    regex: Optional[StrictStr] = None
    regex_error_message: Optional[StrictStr] = Field(default=None, alias="regexErrorMessage")
    hidden: Optional[StrictBool] = None
    disabled: Optional[StrictBool] = None
    empty_values_allowed: Optional[StrictBool] = Field(default=None, alias="emptyValuesAllowed")
    update_render_on_change: Optional[StrictBool] = Field(default=None, alias="updateRenderOnChange")
    __properties: ClassVar[List[str]] = ["id", "type", "label", "minValues", "maxValues", "minMaxValuesMessage", "helpText", "placeHolderText", "values", "dataValues", "minLength", "maxLength", "min", "max", "choices", "dataFilter", "regex", "regexErrorMessage", "hidden", "disabled", "emptyValuesAllowed", "updateRenderOnChange"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of InputFormGroupField from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in data_values (list)
        _items = []
        if self.data_values:
            for _item_data_values in self.data_values:
                if _item_data_values:
                    _items.append(_item_data_values.to_dict())
            _dict['dataValues'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in choices (list)
        _items = []
        if self.choices:
            for _item_choices in self.choices:
                if _item_choices:
                    _items.append(_item_choices.to_dict())
            _dict['choices'] = _items
        # override the default output from pydantic by calling `to_dict()` of data_filter
        if self.data_filter:
            _dict['dataFilter'] = self.data_filter.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of InputFormGroupField from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "type": obj.get("type"),
            "label": obj.get("label"),
            "minValues": obj.get("minValues"),
            "maxValues": obj.get("maxValues"),
            "minMaxValuesMessage": obj.get("minMaxValuesMessage"),
            "helpText": obj.get("helpText"),
            "placeHolderText": obj.get("placeHolderText"),
            "values": obj.get("values"),
            "dataValues": [InputFormWithExternalData.from_dict(_item) for _item in obj["dataValues"]] if obj.get("dataValues") is not None else None,
            "minLength": obj.get("minLength"),
            "maxLength": obj.get("maxLength"),
            "min": obj.get("min"),
            "max": obj.get("max"),
            "choices": [InputFormFieldChoice.from_dict(_item) for _item in obj["choices"]] if obj.get("choices") is not None else None,
            "dataFilter": InputFormFieldDataFilter.from_dict(obj["dataFilter"]) if obj.get("dataFilter") is not None else None,
            "regex": obj.get("regex"),
            "regexErrorMessage": obj.get("regexErrorMessage"),
            "hidden": obj.get("hidden"),
            "disabled": obj.get("disabled"),
            "emptyValuesAllowed": obj.get("emptyValuesAllowed"),
            "updateRenderOnChange": obj.get("updateRenderOnChange")
        })
        return _obj


